      subroutine out2(maxmx,maxmy,meqn,mbc,mx,my,xlower,ylower,
     &                 dx,dy,q,t,iframe,aux,maux)

      implicit none
      integer maxmx, maxmy, meqn,mbc,mx,my,maux,iframe
      double precision xlower,ylower,dx,dy,t
      integer nstp, ipos, idigit,m, mptr, ngrids, level
      integer i,j

      double precision   q(1-mbc:maxmx+mbc, 1-mbc:maxmy+mbc, meqn)
      double precision aux(1-mbc:maxmx+mbc, 1-mbc:maxmy+mbc, maux)
      character*10 fname1, fname2, fname3
      integer meqn1, mq_test, m1
      logical outaux
      double precision err_norm(3), cerr, ttime, total_time
      integer nfevals, get_fcounter

      double precision dt, scale, compute_exact_sum
      double precision sumqt_exact, sumqt, get_initial_sum
      double precision sumq0
      double precision qemax,qemin,qmax,qmin, dqmin, dqmax
      integer mq, dim

      include 'para.i'
      include 'para_exact.i'
      outaux = .false.

c     # first create the file name and open file
c
      fname1 = 'fort.qxxxx'
      fname2 = 'fort.txxxx'
      fname3 = 'fort.axxxx'
      nstp = iframe
      do 55 ipos = 10, 7, -1
         idigit = mod(nstp,10)
         fname1(ipos:ipos) = char(ichar('0') + idigit)
         fname2(ipos:ipos) = char(ichar('0') + idigit)
         fname3(ipos:ipos) = char(ichar('0') + idigit)
         nstp = nstp / 10
   55 continue

      open(unit=50,file=fname1)
      open(unit=60,file=fname2)

c
c     # the following parameters are used in amrclaw where there are
c     # multiple grids.  Here they are all set to 1:
      ngrids = 1
      mptr = 1
      level = 1

      write(50,1001) mptr,level,mx,my
 1001 format(i5,'                 grid_number',/,
     &       i5,'                 AMR_level',/,
     &       i5,'                 mx',/,
     &       i5,'                 my')

      write(50,1002) xlower,ylower,dx,dy
 1002 format(e26.16,'    xlow', /,
     &       e26.16,'    ylow', /,
     &       e26.16,'    dx', /,
     &       e26.16,'    dy',/)


      call stop_timer()
c      nfevals = get_fcounter()
      ttime = total_time()

c     # ------------------------------------------------------------
c     # Compute error
c     # ------------------------------------------------------------
      call exact_solution(mx,my,mbc,
     &      work(xp_ptr),work(yp_ptr),work(zp_ptr),
     &      work_exact(q0_ptr),work_exact(qexact_ptr),t)


      mq_test = 1

      call compute_minmax(maxmx, maxmy, meqn,mbc,mx,my,mq_test,
     &      q,work_exact(qexact_ptr),work_exact(q0_ptr),dqmax,dqmin)


c     # We only output 1 out of meqn fields, since they are all the same.
c     # We only want to test that we can handle muptiple fields.
      call compute_error(maxmx,maxmy,meqn,mbc,mx,my,t,
     &      q,work_exact(qexact_ptr),work_exact(qerr_ptr),
     &      work(area_ptr),mq_test,err_norm)

      meqn1 = meqn + 1
      call write_fort(maxmx, maxmy, meqn, mbc,mx,my,
     &      q, work_exact(qerr_ptr), work_exact(qexact_ptr),
     &      mq_test,aux,maux)


      sumqt_exact = compute_exact_sum(mq_test,t)

c     # Fixed bug 11/14/2010
      call cons_check(maxmx, maxmy,meqn,mbc,mx,my,
     &      q,work(area_ptr),sumqt_exact, mq_test,sumqt,cerr)

      open(10,file = 'errfile.in')
      write(10,120) my,(err_norm(m),m=1,3), cerr, dqmax,dqmin, ttime
      close(10)
      write(6,120) my,(err_norm(m),m=1,3), cerr, dqmax, dqmin, ttime
  120 format(I5,6E24.16,E16.4)

      dim = 2
      write(60,1000) t,meqn1,ngrids,maux, dim

 1000 format(e26.16,'    time', /,
     &       i5,'                 meqn'/,
     &       i5,'                 ngrids'/,
     &       i5,'                 maux'/,
     &       i5,'                 dim',/)
c
      close(unit=50)
      close(unit=60)

      call start_timer()

      return
      end

      subroutine compute_minmax(maxmx, maxmy, meqn,mbc,mx,my,mq,
     &      q,qexact,q0,dqmax,dqmin)
      implicit none

      integer maxmx, maxmy, mx, my, meqn,mbc, mq
      double precision t

      double precision q(1-mbc:maxmx+mbc,1-mbc:maxmy+mbc,meqn)
      double precision q0(0:mx+1,0:my+1)
      double precision qexact(0:mx+1,0:my+1)
      double precision qmax,qmin,qemax,qemin,q0max,q0min
      double precision dq0,dqmin, dqmax

      integer i,j

      qmax = q(1,1,1)
      qmin = q(1,1,1)

      qemax = qexact(1,1)
      qemin = qexact(1,1)

      q0min = q0(1,1)
      q0max = q0(1,1)

      do j = 1,my
         do i = 1,mx
            qemax = max(qexact(i,j),qemax)
            qemin = min(qexact(i,j),qemin)

            qmax  = max(q(i,j,1),qmax)
            qmin  = min(q(i,j,1),qmin)

            q0max = max(q0(i,j),q0max)
            q0min = min(q0(i,j),q0min)
         enddo
      enddo

      dq0 = q0max - q0min
      dqmax = (qmax - qemax)/dq0
      dqmin = (qmin - qemin)/dq0

      end


      subroutine compute_error(maxmx,maxmy,meqn,mbc,mx,my,t,
     &     q,qexact,qerr,area,mq,errv)
      implicit none

      integer maxmx, maxmy, meqn, mbc, mx,my, mq
      double precision t
      double precision q(1-mbc:maxmx+mbc,1-mbc:maxmy+mbc,meqn)
      double precision qerr(0:mx+1,0:my+1)
      double precision qexact(0:mx+1,0:my+1)
      double precision area(-mbc:mx+mbc+1,-mbc:my+mbc+1)
      double precision errv(3), qerr1,a
      double precision area_total
      double precision norme(3), qe

      integer i,j,m, mx1, ii,jj
      logical issphere

      do m = 1,3
         errv(m) = 0
         norme(m) = 0
      enddo

c     # Choose equation to test (meqn = 3;  see parabolic_driver.f)

c      write(6,*) '*** WARNING *** : not computing error in ',
c     &      'diagonal cells'

      area_total = 0
      do j = 1,my
         do i = 1,mx
            a = area(i,j)
            qerr1 = abs(q(i,j,1) - qexact(i,j))
            qe = abs(qexact(i,j))

            errv(1) = errv(1) + a*qerr1
            errv(2) = errv(2) + a*qerr1**2
            errv(3) = max(errv(3),qerr1)

            norme(1) = norme(1) + a*qe
            norme(2) = norme(2) + a*qe**2
            norme(3) = max(norme(3),qe)

            qerr(i,j) = qerr1
            area_total = area_total + area(i,j)
         enddo
      enddo
c      write(6,*) 'end of compute_error'
c      errv(1) = errv(1)/area_total
c      errv(2) = sqrt(errv(2)/area_total)

c     # This is for the NCAR benchmark
      errv(1) = errv(1)/(norme(1))
      errv(2) = sqrt(errv(2)/(norme(2)))
      errv(3) = errv(3)/norme(3)
      end



      subroutine write_fort(maxmx, maxmy, meqn, mbc,mx,my,
     &      q, qerr, qexact, mq_test,aux,maux)
      implicit none

      integer maxmx, maxmy, meqn, mbc,mx,my, mq_test,maux,m1
      double precision q(1-mbc:maxmx+mbc, 1-mbc:maxmy+mbc,meqn)
      double precision aux(1-mbc:maxmx+mbc, 1-mbc:maxmy+mbc,maux)
      double precision q0(0:mx+1,0:my+1)
      double precision qerr(0:mx+1,0:my+1)
      double precision qexact(0:mx+1,0:my+1)

      integer i,j,m


      do  j = 1,my
         do i = 1,mx
            do m = 1,meqn
c              # exponents with more than 2 digits cause problems reading
c              # into matlab... reset tiny values to zero:
               if (dabs(q(i,j,m)) .lt. 1d-99)  then
                  q(i,j,m) = 0.d0
               endif
            enddo
            write(50,1005) (q(i,j,m),m=1,meqn), aux(i,j,1)
         enddo
 1005    format(6e26.16)
         write(50,*) ' '
      enddo
      end
