      subroutine qinit(maxmx,maxmy,meqn,mbc,mx,my,xlower,ylower,
     &      dx,dy,q,maux,aux)
      implicit none

      integer maxmx, maxmy, meqn,mbc,mx,my, maux
      double precision xlower, ylower,dx,dy

      double precision q(1-mbc:maxmx+mbc, 1-mbc:maxmy+mbc, meqn)
      double precision aux(1-mbc:maxmx+mbc, 1-mbc:maxmy+mbc, maux)
      double precision t, compute_initial_sum,s, get_initial_sum

      integer mq_test

      include 'para.i'
      include 'para_exact.i'

c     # It would make more sense to test this in setprob, but I don't have
c     # meqn there.
      if (mq_test_com .gt. meqn) then
         write(6,*) 'qinit_advection : mq_test .gt. meqn'
         stop
      endif
      mq_test = mq_test_com

      call setup_advection(mx,my,mbc,meqn)

c     # Initialize q using data stored in 'para_exact.i'
      t = 0
      call initialize_q(maxmx, maxmy, meqn, mbc, mx,my,
     &      work_exact(q0_ptr),q)

      call set_initial_sum(maxmx,maxmy,meqn,mbc,mx,my,
     &      q,work(area_ptr))

      return
      end

      subroutine initialize_q(maxmx,maxmy,meqn,mbc,mx,my,
     &      q0,q_claw)
      implicit none

      integer maxmx, maxmy, mx,my,meqn,mbc
      double precision q_claw(1-mbc:maxmx+mbc,1-mbc:maxmy+mbc,meqn)
      double precision q0(0:mx+1,0:my+1)

      double precision a,b,c, q1,q2,q3

      integer i,j, m, mq,ichoice, get_init_choice

      ichoice = get_init_choice()
      if (ichoice .eq. 3 .and. meqn .eq. 1) then
         write(6,*) 'Error : Set meqn=2 for correlated cosine bells'
         stop
      endif

      do j = 0,my+1
         do i = 0,mx+1
c           # Constant density
            call scale_shift(q0(i,j),q1,q2)
            q_claw(i,j,1) = q1
            if (ichoice .eq. 3) then
               q_claw(i,j,2) = q2
            endif
         enddo
      enddo

      end

      subroutine scale_shift(qin,q1,q2)
      implicit none

      double precision qin

      double precision a,b,c, q1, q2
      integer ichoice, get_init_choice

      ichoice = get_init_choice()

      q1 = qin

c     # Track the correlated cosine bell along with cosine bell
      a = -0.8d0
      b = 0.9d0

c     # Is this (b + cq)^2, from above?  Or just q^2
      q2 = a*q1**2 + b

      end
