      subroutine setaux(maxmx,maxmy,mbc,mx,my,xlower,ylower,dx,dy,
     &                  maux,aux)
      implicit none

      integer maxmx, maxmy, mbc, mx,my, maux
      double precision xlower, ylower, dx,dy
      double precision aux(1-mbc:maxmx+mbc,1-mbc:maxmy+mbc,maux)

      integer mq, mcapa, idx, meqn

      integer mwork_aux
      parameter (mwork_aux = 12712230)
      double precision work_aux(mwork_aux)
      double precision t
      logical isdiamond

      integer normals

      include 'para.i'

      meqn = meqn_com

      call get_aux_ptrs(mwork_aux,mx,my,mbc,normals)

      call setup_mesh_advection(mx,my,mbc,xlower,ylower,dx,dy)

      call set_capacity(maxmx,maxmy,mx,my,mbc,
     &      work(area_ptr),dx,dy,aux,maux)

      call compute_edge_normals(maxmx,maxmy,mx,my,mbc,
     &      work(xp_ptr),work(yp_ptr),work(zp_ptr),
     &      work(xd_ptr),work(yd_ptr),work(zd_ptr),
     &      dx,dy,work_aux(normals),aux,maux)

      call set_trig_values(maxmx, maxmy, mx,my,mbc,
     &      work(xp_ptr),work(yp_ptr),work(zp_ptr),
     &      work(xd_ptr),work(yd_ptr),work(zd_ptr),
     &      aux,maux)

      t = 0
      call set_velocity(maxmx,maxmy,mx,my,mbc,meqn,
     &      work(xp_ptr),work(yp_ptr),work(zp_ptr),
     &      work(xd_ptr),work(yd_ptr),work(zd_ptr),
     &      xlower,ylower,dx,dy,t,
     &      aux,maux)

      end


      subroutine set_trig_values(maxmx, maxmy, mx, my, mbc,
     &      xp,yp,zp,xd,yd,zd,aux,maux)
      implicit none

      integer mx,my,mbc,maxmx, maxmy, maux

      double precision xp(-mbc:mx+mbc+1,-mbc:my+mbc+1)
      double precision yp(-mbc:mx+mbc+1,-mbc:my+mbc+1)
      double precision zp(-mbc:mx+mbc+1,-mbc:my+mbc+1)

      double precision xd(-mbc:mx+mbc+2,-mbc:my+mbc+2)
      double precision yd(-mbc:mx+mbc+2,-mbc:my+mbc+2)
      double precision zd(-mbc:mx+mbc+2,-mbc:my+mbc+2)

      double precision aux(1-mbc:maxmx+mbc,1-mbc:maxmy+mbc,maux)

      integer i,j
      double precision l,th

      do j = -mbc,my+mbc+1
         do i = -mbc,mx+mbc+1
            call map2polar(xd(i,j),yd(i,j),zd(i,j),l,th)
            aux(i,j,17) = cos(l)
            aux(i,j,18) = sin(l)
            aux(i,j,19) = cos(th)
            aux(i,j,20) = sin(th)
         enddo
      enddo

      do j = 1-mbc,my+mbc
         do i = 1-mbc,mx+mbc
            call map2polar(xp(i,j),yp(i,j),zp(i,j),l,th)
            aux(i,j,21) = cos(l)
            aux(i,j,22) = sin(l)
            aux(i,j,23) = cos(th)
            aux(i,j,24) = sin(th)
         enddo
      enddo


      end

      subroutine fix_mesh(mx,my,mbc,xd,yd,zd)
      implicit none

      integer mx,my, mbc
      double precision xd(-mbc:mx+mbc+2,-mbc:my+mbc+2)
      double precision yd(-mbc:mx+mbc+2,-mbc:my+mbc+2)
      double precision zd(-mbc:mx+mbc+2,-mbc:my+mbc+2)

      integer i,j

c     # Fix top edge
      do i = 1,mx/2 + 1
         xd(mx - i + 2,my+1) = xd(i,my+1)
         yd(mx - i + 2,my+1) = yd(i,my+1)
      enddo

c     # Fix left and right edges
c     # This doesn't not fix the conservation, though
      do j = 1,my+1
         xd(1,j) = xd(mx/2 + j,1)
         yd(1,j) = yd(mx/2 + j,1) + 2.d0
         xd(mx+1,j) = xd(mx/2 - j + 2,1) + 2.d0
         yd(mx+1,j) = yd(mx/2 - j + 2,1)
      enddo


      end

      subroutine set_capacity(maxmx, maxmy,mx,my,mbc,
     &      area,dx,dy,aux,maux)
      implicit none

      integer maxmx, maxmy, mbc, mx,my, maux
      double precision dx,dy

      double precision aux(1-mbc:maxmx+mbc,1-mbc:maxmy+mbc,maux)

      integer i,j
      double precision areafact

      double precision area(-mbc:mx+mbc+1,-mbc:my+mbc+1)
      double precision areamin, areamax, total_area


      areafact = 1.d0/(dx*dy)
      areamin = 100
      areamax = 0
      total_area = 0
      do i = 1-mbc,mx+mbc
         do j = 1-mbc,my+mbc
            aux(i,j,1) = area(i,j)*areafact
            areamin = min(areamin,area(i,j))
            areamax = max(areamax,area(i,j))
            if (i .ge. 1 .and. i .le. mx .and.
     &            j .ge. 1 .and. j .le. my) then
               total_area = total_area + area(i,j)
            endif
         enddo
      enddo
c      write(6,100) 'Total area', total_area
  100 format(A20,F24.16)

      end


      subroutine compute_edge_normals(maxmx, maxmy, mx,my,mbc,
     &      xp,yp,zp,xd,yd,zd,dx,dy,normals,aux,maux)
      implicit none

      integer mx,my,mbc,maxmx, maxmy, maux
      double precision dx,dy

      double precision xp(-mbc:mx+mbc+1,-mbc:my+mbc+1)
      double precision yp(-mbc:mx+mbc+1,-mbc:my+mbc+1)
      double precision zp(-mbc:mx+mbc+1,-mbc:my+mbc+1)

      double precision xd(-mbc:mx+mbc+2,-mbc:my+mbc+2)
      double precision yd(-mbc:mx+mbc+2,-mbc:my+mbc+2)
      double precision zd(-mbc:mx+mbc+2,-mbc:my+mbc+2)

      double precision normals(-mbc:mx+mbc+2,-mbc:my+mbc+2,6)

      double precision aux(1-mbc:maxmx+mbc,1-mbc:maxmy+mbc,maux)

      integer i,j,m
      double precision taud(3),taup(3), sp,sd,st,ct
      double precision nv(3), a1, a2, w(3)

      double precision a11, a12, a22, nlen,s,nv1(3)
      double precision h

      integer version

      data version /1/

c     # Compute normals at all interior edges.

c     # Get x-face normals
      do j = 1-mbc,my+mbc+1
         do i = 1-mbc,mx+mbc+1

            taud(1) = xp(i,j) - xp(i-1,j)
            taud(2) = yp(i,j) - yp(i-1,j)
            taud(3) = zp(i,j) - zp(i-1,j)

            taup(1) = xd(i,j+1) - xd(i,j)
            taup(2) = yd(i,j+1) - yd(i,j)
            taup(3) = zd(i,j+1) - zd(i,j)

            call get_normal(taup,taud,nv,sp)

            h = sp/dy
            do m = 1,3
               normals(i,j,m) = h*nv(m)
            enddo
         enddo
      enddo

      do j = 1-mbc,my+mbc+1
         do i = 1-mbc,mx+mbc+1
c           # Now do y-faces
            taud(1) = xp(i,j) - xp(i,j-1)
            taud(2) = yp(i,j) - yp(i,j-1)
            taud(3) = zp(i,j) - zp(i,j-1)

            taup(1) = xd(i+1,j) - xd(i,j)
            taup(2) = yd(i+1,j) - yd(i,j)
            taup(3) = zd(i+1,j) - zd(i,j)

            call get_normal(taup,taud,nv,sp)
            h = sp/dx
            do m = 1,3
               normals(i,j,3+m) = h*nv(m)
            enddo
         enddo
      enddo

c     # Assign x-face normals
      do j = 1-mbc,my+mbc
         do i = 2-mbc,mx+mbc
            do m = 1,3
               aux(i,j,1+m) = normals(i,j,m)
            enddo
         enddo
      enddo

c     # Assign y-face normals
      do j = 2-mbc,my+mbc
         do i = 1-mbc,mx+mbc
            do m = 1,3
               aux(i,j,4+m) = normals(i,j,3+m)
            enddo
         enddo
      enddo

c     # Compute closure vector
      do j = 1-mbc,my+mbc
         do i = 1-mbc,mx+mbc
            do m = 1,3
               w(m) = (normals(i+1,j,m) - normals(i,j,m) +
     &               normals(i,j+1,3+m) - normals(i,j,3+m))
               aux(i,j,7+m) = w(m)
            enddo
         enddo
      enddo
      end


      subroutine get_aux_ptrs(mwork,mx,my,mbc,normals)
      implicit none

      integer mx,my,mbc,normals
      integer mwork,total, mbc1,np,nd

      mbc1 = mbc+1
      np = (mx+2*mbc1)*(my+2*mbc1)
      nd = (mx+2*mbc1 + 1)*(my+2*mbc1+1)

      normals = 1

      total = normals + 6*nd

      total = total - 1

      if (mwork .lt. total) then
         write(6,*) 'get_ptrs_aux : Increase size of mwork to ',total
         stop
      endif

      end
