      subroutine setprob()
      implicit none

      double precision rand_int, kappa,tfinal
      integer map_type, rot_map, seed
      integer rand_seed
      integer n, m, vflag, ichoice

      double precision rp2, th, lambda, wc(3,10), rps, a, w(3)

      double precision rot_angle(2), rsphere, r, hmax,b,c
      integer meqn

      include 'para.i'
      include 'para_exact.i'

      pi = 4.d0*atan(1.d0)

c     # read in data to see whether we should run with fixed rotation or not.
      open(7,file='setprob.data')
      read(7,*) vflag
      read(7,*) ichoice
      close(7)

      call set_init_choice(ichoice)

c     # -------------------------------------------------
c     # Set velocity flag to cell-centered, or edge centered,
c     # and using stream-function.
c     # -------------------------------------------------
      call set_vflag(vflag)

      kappa = 2.d0
      tfinal = 5.d0
      call set_wind_parms(kappa,tfinal)

c     # -------------------------------------------------
c     # Set up sphere mapping
c     # -------------------------------------------------

      rot_map = 0
      seed = -1
      call setup_mapping(rot_map, seed)

c     # -------------------------------------------------
c     # Setup location of cosine or Gaussians in array wc.
c     # Array 'wc' will be set in common block 'prob.i'
c     # -------------------------------------------------
c     # Locations of cosine bell or Gaussian

      th = 0
      lambda = 5.d0*pi/6.d0
      wc(1,1) = cos(th)*cos(lambda)
      wc(2,1) = cos(th)*sin(lambda)
      wc(3,1) = sin(th)

      th = 0
      lambda = 7.d0*pi/6.d0
      wc(1,2) = cos(th)*cos(lambda)
      wc(2,2) = cos(th)*sin(lambda)
      wc(3,2) = sin(th)

      n = 2

      call set_initial_gaussian_locations(wc,n)

      if (ichoice .eq. 1) then
         a = 5
         hmax = 1d0
         call set_initial_gaussian_parms(a,hmax)
      elseif (ichoice .eq. 2 .or. ichoice .eq. 3) then
         r = 0.5d0
         hmax = 1.d0
         b = 0.1d0
         c = 0.9d0
         call set_initial_cosbell_parms(r,hmax,b,c)
      elseif (ichoice .eq. 4) then
         r = 0.5d0
         hmax = 1.d0
         b = 0.1d0
         c = 1d0
         call set_initial_sdisk_parms(r,hmax,b,c)
      endif

c     # -------------------------------------------------
c     # Other things
c     # -------------------------------------------------


c c     # I set meqn in driver_claw.   The dimension of
c       meqn = meqn_com
c       if (meqn .gt. maxmeqn2) then
c          write(6,*) 'setprob : Increase size of maxmeqn2 to ', meqn
c          write(6,*) 'See prob.i'
c          stop
c       endif

      end

      subroutine set_init_choice(ichoice)
      implicit none

      integer ichoice, ichoice_com

      common /cominit/ ichoice_com

      ichoice_com = ichoice


      end

      integer function get_init_choice()
      implicit none

      common /cominit/ ichoice_com
      integer ichoice_com

      get_init_choice = ichoice_com

      end
