      subroutine src2(maxmx,maxmy,meqn,mbc,mx,my,xlower,ylower,
     &                 dx,dy,q,maux,aux,t,dt)
      implicit none

      integer maxmx, maxmy, meqn,mbc,mx,my, maux
      double precision xlower,ylower,dx,dy, t, dt

      double precision q(1-mbc:maxmx+mbc, 1-mbc:maxmy+mbc, meqn)
      double precision aux(1-mbc:maxmx+mbc, 1-mbc:maxmy+mbc, maux)

      integer ierror, mq
      double precision ti, tend
      logical nv(10)

      logical has_parabolic_term


c     # -------------------------------------------
c     # Time has already been incremented in claw2, so we have to
c     # de-increment it here, in case the reaction term depends
c     # explicitly on time
c     # -------------------------------------------
      ti = t - dt
      tend = t

c     # -------------------------------------------
c     # If the reaction terms are not coupled, then
c     # is it slightly faster to do each diffusion
c     # solve separately.
c     #
c     # Otherwise, you can make a single call to
c     # parabolic_step and all diffusion terms will
c     # be updated simultaneously.
c     # -------------------------------------------


c     # -------------------------------------------
c     # Single call to parabolic_step
c     # -------------------------------------------
c      do mq = 1,meqn
c         nv(mq) = .true.
c      enddo
c      call parabolic_step(maxmx,maxmy,meqn,mbc,mx,my,nv,
c     &      q,ti,dt)
c     # -------------------------------------------


c     # -------------------------------------------
c     # Separate calls to parabolic_step
c     # -------------------------------------------
      do mq = 1,meqn
         nv(mq) = .false.
      enddo
      do mq = 1,meqn
c        # If equation has no parabolic term, than 'parabolic_step' returns
c        # without doing anything.
         nv(mq) = has_parabolic_term(mq)
         call parabolic_step(maxmx,maxmy,meqn,mbc,mx,my,nv,
     &         q,ti,dt,ierror)
         nv(mq) = .false.
      enddo
c     # -------------------------------------------

c     # This is for printing information if verbosity is set to 2 or 3.
      call increment_time_step_counter()

  100 format(A,I5)
      return
      end
