      double precision function psi(xd,yd,zd,t)
      implicit none

      integer mq
      double precision xd, yd, zd, t
      double precision l, th, lp, Tfinal, kappa, pi

      common /compi/ pi

c      kappa = 2.d0
c      Tfinal = 5.d0
      call get_wind_parms(kappa,tfinal)

      call map2polar(xd,yd,zd,l,th)

      lp = l - 2*pi*t/Tfinal


      psi = kappa*sin(lp)**2*cos(th)**2*cos(pi*t/Tfinal) -
     &      2*pi*sin(th)/Tfinal

c     # Sign difference from Benchmark problem
      psi = -psi


      end


      subroutine get_vel(xp,yp,zp,vvec,t)
      implicit none

      integer mq
      double precision xp,yp,zp,vvec(3), t
      double precision rsphere, get_rsphere
      double precision kappa,Tfinal, th, l, lp, pi
      double precision Tl(3), Tth(3), u, v
      double precision cth, sth, cl, sl
      integer m

      common /compi/ pi

      call get_wind_parms(kappa,Tfinal)

      call map2polar(xp,yp,zp,l,th)

      lp = l - 2*pi*t/Tfinal

      cth = cos(th)
      sth = sin(th)
      cl = cos(l)
      sl = sin(l)

c     # Normalized basis vectors for spherical coordinates
      Tl(1) = -sl
      Tl(2) =  cl
      Tl(3) = 0

      Tth(1) = -sth*cl
      Tth(2) = -sth*sl
      Tth(3) = cth

c     # Velocity of spherical coordinates
      u = -(kappa/2.d0)*sin(lp/2.d0)**2*sin(2*th)*cos(pi*t/Tfinal) +
     &      2*pi*cth/Tfinal
      v = (kappa/4.d0)*sin(lp)*(cth**3)*cos(pi*t/Tfinal)

c     # Get Cartesian components of the velocity vector
      do m = 1,3
         vvec(m) = u*Tl(m) + v*Tth(m)
      enddo

      end
