      double precision function psi(trig_values,t)
      implicit none

      integer mq
      double precision trig_values(4),t
      double precision l, th, lp, Tfinal, kappa, pi
      double precision sl,cl,cth,sth, ct,st, w, wt, wl
      integer m

      common /compi/ pi


      kappa = 2.d0
      Tfinal = 5.d0
c      call get_wind_parms(kappa,tfinal)

      cl = trig_values(1)
      sl = trig_values(2)
      cth = trig_values(3)
      sth = trig_values(4)

      w = 2*pi/Tfinal
      wt = w*t

      ct = cos(wt)
      st = sin(wt)

c      lp = l - 2*pi*t/Tfinal
c      psi = kappa*sin(lp)**2*cos(th)**2*cos(pi*t/Tfinal) -
c     &      2*pi*sin(th)/Tfinal

      wl = sl*ct - cl*st

      psi = kappa*(wl**2)*(cth**2)*cos(pi*t/Tfinal) - w*sth

c     # Sign difference from Benchmark problem
      psi = -psi




      end


      subroutine get_vel(xp,yp,zp,vvec,mq,t)
      implicit none

      integer mq
      double precision xp,yp,zp,vvec(3), t
      double precision rsphere, get_rsphere
      double precision kappa,Tfinal, th, l, lp, pi
      double precision Tl(3), Tth(3), u, v
      double precision cth, sth, cl, sl
      integer m

      common /compi/ pi

c      kappa = 2.d0
c      Tfinal = 5.d0

      call get_wind_parms(kappa,Tfinal)

      call map2polar(xp,yp,zp,l,th)

      lp = l - 2*pi*t/Tfinal

      cth = cos(th)
      sth = sin(th)
      cl = cos(l)
      sl = sin(l)

c     # Normalized basis vectors for spherical coordinates
      Tl(1) = -sl
      Tl(2) =  cl
      Tl(3) = 0

      Tth(1) = -sth*cl
      Tth(2) = -sth*sl
      Tth(3) = cth

c     # Velocity of spherical coordinates
      u = kappa*sin(lp)**2*sin(2*th)*cos(pi*t/Tfinal) +
     &      2*pi*cth/Tfinal
      v = kappa*sin(2*lp)*cth*cos(pi*t/Tfinal)

c     # Get Cartesian components of the velocity vector
      do m = 1,3
         vvec(m) = u*Tl(m) + v*Tth(m)
      enddo

      end
