      program driver
c
c  Generic driver routine for claw2
c
c  Author: Randall J. LeVeque
c  Version of March, 1999 --  CLAWPACK Version 4.0
c
c
      implicit none

c     # set parameters for maximum array sizes used in declarations
c     # these must be increased for larger problems.
c
      integer maxmx, maxmy, mwork_driver, mbc,meqn,mwaves,maux

      parameter (maxmx =   2048)
      parameter (maxmy =   1024)
      parameter (mwork_driver =  6560244)

      parameter (mbc = 2)
      parameter (meqn = 2)
      parameter (mwaves = 2)
      parameter (maux = 3)

      double precision    q(1-mbc:maxmx+mbc, 1-mbc:maxmy+mbc, meqn)
      double precision  aux(1-mbc:maxmx+mbc, 1-mbc:maxmy+mbc, maux)
      double precision mthlim(mwaves)
      double precision work_driver(mwork_driver)

      include 'para.i'

c     # This seems to be the only way to get meqn into setaux...
      meqn_com = meqn

c     # This will be overwritten if we are solving an advection diffusion problem.
      method_com = 1

c     # This will set the proper map (disk,hemisphere, sphere) depending on
c     # which file was compiled in.

      call set_maptype()

      call start_timer()
      call claw2ez(maxmx,maxmy,meqn,mwaves,mbc,maux,mwork_driver,mthlim,
     &           q,work_driver,aux)
      call stop_timer()

      stop
      end
