function plot_div()

clear all;

fname{1}  = 'div-CLAW-dx0.1875-un-CFL0.95.dat.1';
fname{2}  = 'div-CLAW-dx0.1875-un-CFL0.95.dat.2';

fname{3}  = 'div-CLAW-dx0.28125-sp-CFL0.95.dat.1';
fname{4}  = 'div-CLAW-dx0.28125-sp-CFL0.95.dat.2';

fname{5}  = 'div-CLAW-dx0.75-sp-CFL0.95.dat.1';
fname{6}  = 'div-CLAW-dx0.75-sp-CFL0.95.dat.2';

fname{7}  = 'div-CLAW-dx0.75-un-CFL0.95.dat.1';
fname{8}  = 'div-CLAW-dx0.75-un-CFL0.95.dat.2';

fname{9}  = 'div-CLAW-dx1.5-sp-CFL0.95.dat.1';
fname{10} = 'div-CLAW-dx1.5-sp-CFL0.95.dat.2';

fname{11} = 'div-CLAW-dx1.5-un-CFL0.95.dat.1';
fname{12} = 'div-CLAW-dx1.5-un-CFL0.95.dat.2';

my_vec = [240 240 160 160 120 120 120 120 60 60 60 60];

for i = 1:12,
  figure(i);
  llong = 4*my_vec(i);
  llat = 2*my_vec(i);

  f = load(fname{i});
  xm = reshape(f(:,1),llong,llat);
  ym = reshape(f(:,2),llong,llat);
  q = reshape(f(:,3),llong,llat);

  p(i) = pcolor(xm,ym,q);
  set(p(i),'edgecolor','none');
  caxis([-0.1 1.1]);
  daspect([1 1 1]);
  tstr = title_str(fname{i},llong,llat);
  title(tstr,'fontsize',18);

  prt = true;
  if (prt == true)
    str = [fname{i} '.png'];
    prtstr = ['print -dpng ' str];
    fprintf('%s\n',prtstr);
    eval(['print -dpng ' str]);
  end;
end;


% ------------------------------------------------------------
function tstr = title_str(fname,mx,my)

tstr = sprintf('%s (%d x %d)',fname,mx,my);
