      subroutine set_initial_sum(maxmx, maxmy,meqn,mbc,mx,my,q,area)
      implicit none

      integer maxmx, maxmy, meqn, mbc,mx,my
      double precision q(1-mbc:maxmx+mbc,1-mbc:maxmy+mbc,meqn)
      double precision area(-mbc:mx+mbc+1,-mbc:my+mbc+1)
      double precision compute_initial_sum

      integer mq

      integer maxmq
      parameter(maxmq = 20)
      double precision sumq0_com(maxmq)

      common /comcons/ sumq0_com

      if (meqn .gt. maxmq) then
         write(6,*) 'set_initial_sum (conscheck.f ) : ',
     &         'Increase size of maxmq to ', meqn
         stop
      endif

      do mq = 1,meqn
         sumq0_com(mq) = compute_initial_sum(maxmx,maxmy,
     &         meqn,mbc,mx,my,q,area,mq)
      enddo

      end

      double precision function get_initial_sum(mq)
      implicit none
      integer mq

      integer maxmq
      parameter(maxmq = 20)
      double precision sumq0_com(maxmq)

      common /comcons/ sumq0_com

      if (mq .gt. maxmq) then
         write(6,*) 'get_initial_sum (conscheck.f) : mq > maxmq'
         stop
      endif

      get_initial_sum = sumq0_com(mq)

      end

      double precision function compute_initial_sum(maxmx,maxmy,
     &      meqn,mbc,mx,my,q_claw,area,mq_test)
      implicit none

      integer maxmx, maxmy, meqn, mbc,mx,my, mq_test
      double precision q_claw(1-mbc:maxmx+mbc,1-mbc:maxmy+mbc,meqn)
      double precision area(-mbc:mx+mbc+1,-mbc:my+mbc+1)

      double precision sumq0
      integer i,j

      sumq0 = 0
      do j = 1,my
         do i = 1,mx
            sumq0 = sumq0 + q_claw(i,j,mq_test)*area(i,j)
         enddo
      enddo
      compute_initial_sum = sumq0

      end


      subroutine cons_check(maxmx, maxmy,meqn,mbc,mx,my,
     &      q,area,sumqt_exact,mq,sumqt,cerr)
      implicit none

      integer maxmx, maxmy, mx,my,mbc,meqn,mq
      double precision sumqt_exact
      double precision q(1-mbc:maxmx+mbc,1-mbc:maxmy+mbc,meqn)
      double precision area(-mbc:mx+mbc+1,-mbc:my+mbc+1)

      integer i,j
      double precision sumqt, cerr

      sumqt = 0
      do i = 1,mx
         do j = 1,my
            sumqt = sumqt + q(i,j,mq)*area(i,j)
         enddo
      enddo

c     # We don't just call get_initial_sum here, since problems
c     # with source terms may not be exactly conservative, but you
c     # know how much should be leaving the domain at time t.

c      sumqt = compute_exact_sum(mx,my,mbc,q0,area,t)

      if (abs(sumqt_exact) .gt. 1e-12) then
         cerr = abs(sumqt - sumqt_exact)/sumqt_exact
      else
         cerr = abs(sumqt - sumqt_exact)
      endif

      end
