      subroutine out2(maxmx,maxmy,meqn,mbc,mx,my,
     &      xlower,ylower,dx,dy,q,area,t,iframe)
c     # -----------------------------------------------------------
c     # PARABOLIC_OUTPUT
c     #
c     # Output the results for a general system of conservation laws
c     # in 2 dimensions
c     #
c     # Write the results to the file fort.q<iframe>
c     # Use format required by matlab script  plotclaw2.m
c     # The same format is used by the amrclaw package.
c     # Here it's adapted to output just the single grid.
c     #
c     # This file is a slightly modified version of 'out2.f'
c     # from CLAWPACK and has the same functionality as that file.
c     #
c     # This is only really needed if the parabolic solver is being
c     # run without clawpack.
c     #
c     # -----------------------------------------------------------
      implicit none

      integer maxmx, maxmy, meqn, mbc, mx,my, iframe
      double precision xlower,ylower,dx,dy,t
      double precision   q(1-mbc:maxmx+mbc, 1-mbc:maxmy+mbc, meqn)
      character*10 fname1, fname2

      double precision area(-mbc:mx+mbc+1,-mbc:my+mbc+1)

      integer nstp, ipos, idigit, ngrids, mptr,level, maux
      integer i,j,m, meqn1

      maux = 0

c     # A step counter for the RKC solver.

c     # This gets reset after we create an output file.  It is incremented
c     # in src2_claw.f.

      call initialize_time_step_counter()

      fname1 = 'fort.qxxxx'
      fname2 = 'fort.txxxx'
      nstp = iframe
      do ipos = 10, 7, -1
         idigit = mod(nstp,10)
         fname1(ipos:ipos) = char(ichar('0') + idigit)
         fname2(ipos:ipos) = char(ichar('0') + idigit)
         nstp = nstp / 10
      enddo

      open(unit=50,file=fname1)
      open(unit=60,file=fname2)


c     # the following parameters are used in amrclaw where there are
c     # multiple grids.  Here they are all set to 1:
      ngrids = 1
      mptr = 1
      level = 1

      write(50,1001) mptr,level,mx,my
 1001 format(i5,'                 grid_number',/,
     &       i5,'                 AMR_level',/,
     &       i5,'                 mx',/,
     &       i5,'                 my')

      write(50,1002) xlower,ylower,dx,dy
 1002 format(e26.16,'    xlow', /,
     &       e26.16,'    ylow', /,
     &       e26.16,'    dx', /,
     &       e26.16,'    dy',/)
c
      do j = 1,my
         do  i = 1,mx
            do m = 1,meqn
c              # exponents with more than 2 digits cause problems reading
c              # into matlab... reset tiny values to zero:
               if (abs(q(i,j,m)) .lt. 1d-99)  then
                  q(i,j,m) = 0.d0
               endif
            enddo
            write(50,1005) (q(i,j,m), m=1,meqn), area(i,j)
         enddo
         write(50,*) ' '
      enddo
 1005 format(10e26.16)
      write(50,*) ' '

      meqn1 = meqn+1
      write(60,1000) t,meqn1,ngrids,maux,2

 1000 format(e26.16,'    time', /,
     &      i5,'                 meqn'/,
     &      i5,'                 ngrids'/,
     &      i5,'                 maux'/,
     &      i5,'                 ndim'/,/)
c
      close(unit=50)
      close(unit=60)

      return
      end
