c  !       # -----------------------------------------------------
c  !       # parabolic_step_irkc
c  !       #
c  !       # Advance the parabolic step from time 't' to time 't + dt'.
c  !       #
c  !       #      nv(mq) = .true.  ==> diffuse species mq
c  !       #      nv(mq) = .false. ==> do not diffuse species mq
c  !       # mq = 1,..,meqn
c  !       #
c  !       # Normally, you have 'nv(mq) == plist(mq)'.  The only case
c  !       # in which this is not a good choice is the situation in which
c  !       # the sources terms containing the diffusion terms are
c  !       # completely decoupled.  In this case, it is much faster to
c  !       # solve each diffusion term separately.
c  !       #
c  !       # After each call, Check ierror to make sure that the RKC
c  !       # solver returned a valid solution.
c  !       #
c  !       #  ierror == 0   Normal exit
c  !       #
c  !       #  ierror  > 0   Problem with RKC solver.   Usually this
c  !       #                means that your time step is too large
c  !       #                for the requested accuracy.  See the
c  !       #                description of 'idid' in the RKC documentation.
c  !       #
c  !       # This routine is called either from the 'src2' routine in
c  !       # clawpack, or directly from 'parabolic_main' (if the clawpack
c  !       # driver is not being used.
c  !       # -----------------------------------------------------

      subroutine irkc()
      end

      SUBROUTINE parabolic_step_irkc(maxmx,maxmy,meqn,mbc,
     &      mx,my,nv,q_claw,t,dt,ierror)

      write(6,*) 'This is a dummy routine.  To use the ',
     &      ' IRKC solver, compile using ',
     &      '''parabolic_step_irkc.f90'''
      stop

      END SUBROUTINE parabolic_step_irkc



      SUBROUTINE set_irkc_stats(sol)
      write(6,*) 'set_irkc_stats : This is a dummy routine'
      end


      SUBROUTINE irkc_stats(tip1,dt,step_counter)
      END SUBROUTINE irkc_stats

      SUBROUTINE irkc_stats_short(tip1,dt,step_counter)
      END SUBROUTINE irkc_stats_short


      INTEGER FUNCTION get_stages_irkc()
      END FUNCTION get_stages_irkc

      INTEGER FUNCTION get_fevals_irkc()
      END FUNCTION get_fevals_irkc


      SUBROUTINE ps_copy_from_claw_irkc(maxmx, maxmy, mbc,
     &      meqn,nactive,mx,my,q_claw, q)
      END SUBROUTINE ps_copy_from_claw_irkc

      SUBROUTINE ps_copy_to_claw_irkc(maxmx, maxmy, mbc,meqn,
     &      nactive,mx,my,q,q_claw)
      END SUBROUTINE ps_copy_to_claw_irkc


      SUBROUTINE copy_to_work(mx,my,meqn,nactive,q,qwork)
      END SUBROUTINE copy_to_work

      SUBROUTINE copy_from_work(mx,my,meqn,nactive,qwork,q)
      END SUBROUTINE copy_from_work
